-- Time-stamp: <2006-12-10 16:03:08 cklin>

module Infopipes.Syntax where

type Port = (PortType, PortName)
data PortType = Inport | Outport deriving (Eq, Show)
newtype PortName = PortName { port_name :: String }
    deriving (Eq, Show)

data Statement
    = Single String
    | Block String String [Statement]
    | Alt [Statement]
    | Cond [(String, Statement)]
    | Input String PortName String
    | Output PortName String String
      deriving (Eq, Show)

data Infopipe = Infopipe
    { pipe_package :: String,
      pipe_imports :: String,
      pipe_super :: String,
      pipe_name :: String,
      pipe_ports :: [Port],
      pipe_body :: Statement }
    deriving (Eq, Show)

data PipeObject = PipeObject
    { push_paths :: [Statement],
      pull_paths :: [Statement],
      posv_ports :: [(Int, Port)],
      obj_config :: String }

