-- Time-stamp: <2006-12-06 17:33:41 cklin>

module Infopipes.Tests.Utils where

import Test.HUnit
import Infopipes.Utils

--

once_tests = TestLabel "once" $ TestList
    [once_0, once_1, once_2]

once_0 = TestCase $ [1,2,3] @=? once [1,2,3]
once_1 = TestCase $ [1,2,3] @=? once [1,4,2,3,4]
once_2 = TestCase $ [1,2,3] @=? once [4,1,2,5,3,4,4,5]

--

cartesian_tests = TestLabel "once" $ TestList
    [cartesian_0, cartesian_1, cartesian_2,
     cartesian_3, cartesian_4, cartesian_5]

cartesian_0 = TestCase $ [[]] @=? cartesian ([] :: [[Int]])
cartesian_1 = TestCase $ [] @=? cartesian [[3,4], []]
cartesian_2 = TestCase $ [[1,2]] @=? cartesian [[1], [2]]
cartesian_3 = TestCase $ [[1,2], [3,2]] @=? cartesian [[1,3], [2]]
cartesian_4 = TestCase $ [[1,2], [1,4]] @=? cartesian [[1], [2,4]]
cartesian_5 = TestCase $ [[1,2], [1,4], [3,2], [3,4]]
                  @=? cartesian [[1,3], [2,4]]

--

unit_tests = runTestTT $ TestList
    [once_tests, cartesian_tests]

