-- Time-stamp: <2006-12-11 00:06:15 cklin>

module Main where

import Control.Monad
import Data.List
import System.Environment
import System.Exit
import Text.ParserCombinators.Parsec
import Infopipes.Syntax
import Infopipes.Parser
import Infopipes.Compiler
import Infopipes.Utils

save_physical :: Infopipe -> PipeObject -> IO ()
save_physical pipe pipe_obj =
    do let name = pipe_name pipe
           tag = "PhysicalPipe"
           config = obj_config pipe_obj
           file = concat [name, tag, config, ".java"]
           code = format_physical pipe pipe_obj
       writeFile file code

save_logical :: Infopipe -> [PipeObject] -> IO ()
save_logical pipe pipe_objs =
    do let name = pipe_name pipe
           tag = "LogicalPipe"
           file = concat [name, tag, ".java"]
           code = format_logical pipe (map obj_config pipe_objs)
       writeFile file code

main =
    do command_args <- getArgs
       when (null command_args)
            (error "I need a source file command argument")
       let source_name = head command_args
       source <- readFile source_name
       case parse program source_name source of
         Left err -> print err
         Right pipe ->
             do let pipe_objs = compile pipe
                save_logical pipe pipe_objs
                mapM_ (save_physical pipe) pipe_objs

